#include "testApp.h"

//videoUpdateFrame(VideoWindow* pWnd, void* pData, long dataSize);
unsigned char * gworldBuf;
unsigned char * rgbPixels;



OSErr
testApp::videoInitOffscreen (int width, int height)
{
	OSErr err;
	
	// create the offscreen target
	dstPortBounds.left = 0;
	dstPortBounds.right = width;
	dstPortBounds.top = 0;
	dstPortBounds.bottom = height;
	
	gworldBuf				= (unsigned char*)malloc(4 * width * height + 32);
	rgbPixels				= new unsigned char[width*height*3];
	if (err = QTNewGWorldFromPtr(&dstPort, k32ARGBPixelFormat, &dstPortBounds, NULL, NULL, 0, gworldBuf, width*4))
	{
		printf("createOffscreenGWorld err=%d\n", err);
		goto endFunc;	
	}
	
	// Get buffer from GWorld
	pDstData			= GetPixBaseAddr(GetGWorldPixMap(dstPort));
	dstDataSize			= GetPixRowBytes(GetGWorldPixMap(dstPort)) * (dstPortBounds.bottom - dstPortBounds.top); 
	dstDisplayBounds	= dstPortBounds;
	
	
	
endFunc:
	return err;
}





//--------------------------------------------------------------
void testApp::setup(){	 
	
	camWidth 		= 640;	// try to grab at this size. 
	camHeight 		= 480;
	
	//vidGrabber.setVerbose(true);
	//vidGrabber.initGrabber(camWidth,camHeight);
	
	//videoInverted 	= new unsigned char[camWidth*camHeight*3];
	videoTexture.allocate(camWidth,camHeight, GL_RGB);
	
	
	OSErr err;
	
	if(!(pVdg = vdgNew()))
	{
		printf("vdgNew: failed to allocate\n");	
		goto endFunc;
	}
	
	if(err = vdgInit(pVdg))
	{
		printf("vdgInit err=%d\n", err);
		goto endFunc;
	}
	
	if(err = vdgRequestSettings(pVdg))
	{
		printf("vdgRequestSettings err=%d\n", err);
		goto endFunc;
	}
	
	if(err = vdgPreflightGrabbing(pVdg))
	{
		printf("vdgPreflightGrabbing err=%d\n", err);
		goto endFunc;
	}
	
	// Set the timer frequency from the Vdig's Data Rate
	//videoSetTimerPeriodFromVdig(pWnd);
	
    vdImageDesc = (ImageDescriptionHandle)NewHandle(0);
	if (err = vdgGetImageDescription( pVdg, 
									 vdImageDesc))
	{
		printf("vdgGetImageDescription err=%d\n", err);
		goto endFunc;
	}
	
	// now initialize glut
	//glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA); 
	//glutInitWindowSize ((*vdImageDesc)->width, (*vdImageDesc)->height);
	//winID = glutCreateWindow("Video Window");
	
	// add to the window management list

	
	

	/*videoInitTexture(   pWnd, 
					 (*vdImageDesc)->width, 
					 (*vdImageDesc)->height);
	*/
	
	// Now create the offscreen GWorld to match the texture
	if (err = videoInitOffscreen(camWidth, camWidth))
	{
		printf("videoInitOffscreen err=%d\n", err);
		goto endFunc;
	}
	
	// Set the decompression destination to the offscreen GWorld
	if (err = vdgSetDestination(	pVdg,
								dstPort ))
	{
		printf("vdgGetImageDescription err=%d\n", err);
		goto endFunc;	
	}
	
	// Set the display bounds to match only the part of the texture
	// that corresponds to the video image
	//videoSetDisplayBoundsToCaptureBounds(pWnd);
	
	if (err = vdgStartGrabbing(pVdg))
	{
		printf("vdgStartGrabbing err=%d\n", err);
		goto endFunc;
	}


	endFunc:
		return;
	
}


//--------------------------------------------------------------
void testApp::update(){
	
	ofBackground(100,100,100);
	
	OSErr	err;
	int		isUpdated = 0;
	
	// Stop the timer is we're not grabbing
	if (!vdgIsGrabbing( pVdg))
		return;
	
	if (err = vdgIdle( pVdg, &isUpdated))
	{
		printf("vdgIdle err=%d\n", err);
		return;
	}
	
	if (isUpdated)
	{
		printf("got data \n");
		//videoUpdateFrame(pWnd, pDstData, dstDataSize);
		//glutPostRedisplay();
		
		
			
		/*
		int depth				= (*GetGWorldPixMap(dstPort))->pixelSize / 8; // size of a pixel in bytes e.g. 3 for RGB, 2 for Y'CbCr 
		int temp				= GetPixRowBytes(GetGWorldPixMap(dstPort)) ;
		int glUnpackAlignment	=  (1 << (int) ceil(log2(temp))) - depth * (dstPortBounds.right-dstPortBounds.left);
		int glUnpackRowLength	=  dstPortBounds.right-dstPortBounds.left;
		
		glPixelStorei(GL_UNPACK_ALIGNMENT, glUnpackAlignment);
		glPixelStorei(GL_UNPACK_ROW_LENGTH, glUnpackRowLength);*/
		convertPixels((unsigned char *)pDstData, rgbPixels, camWidth,camHeight);
		
		//ARGB
		videoTexture.loadData( rgbPixels, camWidth, camHeight, GL_RGB);
	}
	

}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetColor(0xffffff);
	videoTexture.draw(0,0);
}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	
}


//--------------------------------------------------------------
void testApp::keyReleased(int key){ 
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}
